SystemOrganization addCategory: #'Cache-Analysis'!

Object subclass: #NaiveCacheDetector
	instanceVariableNames: ''
	classVariableNames: 'methodToCacheAssocList'
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 19:54'!
LRUCacheUsers
	"(self new LRUCacheUsers collect: [:method | method methodClass -> method selector]) printString"
	^ ((LRUCache allCallsOnIn: SystemNavigation new ) collect: [:method | method methodClass -> method selector]) remove: (NaiveCacheDetector->#LRUCacheUsers); asSet ! !

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 19:54'!
TTLCacheUsers
	"(self new TTLCacheUsers collect: [:method | method methodClass -> method selector]) printString"
	^ ((TTLCache allCallsOnIn: SystemNavigation new ) collect: [:method | method methodClass -> method selector]) remove: (NaiveCacheDetector->#TTLCacheUsers); asSet ! !

!NaiveCacheDetector methodsFor: 'automatic' stamp: 'NickPapoulias 9/8/2015 18:05'!
allAutomaticallyDetectedCaches
	
	| classToCacheAssocList |
	classToCacheAssocList := OrderedCollection new.
	ProtoObject allSubclasses do: [ :class | 
		(self cachesForClass: class) 
			ifNotEmptyDo: [:caches | 
					caches do: [ :cache | classToCacheAssocList add: class -> cache asSymbol ]].
		(self cachesForClassInClassVars: class)
			ifNotEmptyDo: [:caches | 
					caches do: [ :cache | classToCacheAssocList add: class -> cache asSymbol ]]
	].
	^ classToCacheAssocList asSet! !

!NaiveCacheDetector methodsFor: 'full - union - intersection' stamp: 'NickPapoulias 9/8/2015 18:06'!
allCachesInTheSystem

	^ self allAutomaticallyDetectedCaches union: self allManuallyDetectedCaches.
		! !

!NaiveCacheDetector methodsFor: 'manual' stamp: 'NickPapoulias 9/8/2015 17:57'!
allManuallyDetectedCaches

	^ {ASTCache -> #default.
AbstractMethodWidget -> #MethodsIconsCache.
AbstractNautilusUI -> #ClasssesIconsCache.
AbstractNautilusUI -> #GroupsIconsCache.
AbstractNautilusUI -> #PackagesIconsCache.
BitBlt -> #CachedFontColorMaps.
BitBlt -> #ColorConvertingMaps.
CairoBackendCache -> #soleInstance.
Color -> #CachedColormaps.
Color -> #MaskingMap.
FreeTypeCache -> #current.
GLMUIThemeExtraIcons -> #icons.
GradientFillStyle -> #PixelRampCache.
HelpIcons -> #Icons.
KomitClass -> #classes.
KomitMethod -> #methods.
KomitPackage -> #packages.
KomitRemote -> #icon.
Komitter -> #lastMessage.
LoadingMorphState -> #image.
LogicalFont -> #all.
MCDefinition -> #Instances.
MCGitHubRepository -> #DownloadCache.
MCMethodDefinition -> #Definitions.
MCSaveVersionDialog -> #PreviousMessages.
NECSymbols -> #cachedSymbols.
RPackageSet -> #cachePackages.
ScrollBar -> #ArrowImagesCache.
ScrollBar -> #BoxesImagesCache.
SettingDeclaration -> #ValueListCache.
SingleCodeCriticResultList -> #icons.
SugsSuggestionFactory -> #collectorForAll.
SugsSuggestionFactory -> #collectorForAssignment.
SugsSuggestionFactory -> #collectorForClassVariable.
SugsSuggestionFactory -> #collectorForClass.
SugsSuggestionFactory -> #collectorForInstancesVariable.
SugsSuggestionFactory -> #collectorForLiteral.
SugsSuggestionFactory -> #collectorForMessage.
SugsSuggestionFactory -> #collectorForMethod.
SugsSuggestionFactory -> #collectorForSourceCode.
SugsSuggestionFactory -> #collectorForTemporaryVariable.
SugsSuggestionFactory -> #collectorForUndeclaredVariable.
ASTCache -> #default.
ActiveEvent -> #ActiveEvent.
ActiveHand -> #ActiveHand.
ActiveWorld -> #ActiveWorld.
Author -> #uniqueInstance.
BorderStyle -> #Default.
CPUWatcher -> #CurrentCPUWatcher.
CairoBackendCache -> #soleInstance.
ChangesLog -> #DefaultInstance.
Clipboard -> #Default.
CommandLineArguments -> #singleton.
CriticWorkingConfiguration -> #Current.
Display -> #Display.
EditorFindReplaceDialogWindow -> #Singleton.
EmptyLayout -> #instance.
FreeTypeCache -> #current.
FreeTypeSettings -> #current.
IdentityTransform -> #Default.
InputEventFetcher -> #Default.
KMBuffer -> #uniqueInstance.
KMPragmaKeymapBuilder -> #UniqueInstance.
KMRepository -> #Singleton.
KomitterManager -> #instance.
LayoutEmptyScope -> #instance.
LogicalFontManager -> #current.
MBConfigurationRoot -> #Current.
MCFileTreeFileUtils -> #Current.
MCRepositoryGroup -> #default.
MCServerRegistry -> #uniqueInstance.
MetacelloPlatform -> #Current.
NBExternalResourceManager -> #soleInstance.
NECController -> #uniqueInstance.
NNavNavigation -> #Instance.
NNavNavigation -> #Instance.
NativeBoost -> #Current.
NautilusMonticello -> #Default.
OSPlatform -> #Current.
PharoFilesOpener -> #Default.
ProcessSpecificVariable -> #soleInstance.
Processor -> #Processor.
RBRefactoringManager -> #Instance.
RBRefactoryChangeManager -> #Instance.
RPackageOrganizer -> #default.
RecentMessageList -> #UniqueInstance.
Sensor -> #Sensor.
Smalltalk -> #Smalltalk.
SoundTheme -> #Current.
SourceFiles -> #SourceFiles.
StartupPreferencesLoader -> #UniqueInstance.
SystemAnnouncer -> #announcer.
SystemOrganization -> #SystemOrganization.
SystemProgressMorph -> #UniqueInstance.
SystemVersion -> #Current.
Transcript -> #Transcript.
UUIDGenerator -> #Default.
Undeclared -> #Undeclared.
VTermOutputDriver -> #stderrTerminalInstance.
VTermOutputDriver -> #stdoutTerminalInstance.
World -> #World.
ZnNetworkingUtils -> #Default.
MCGitHubRepository -> #DownloadCache.
MCCacheRepository -> #default.
DiskStore -> #CurrentFS.
NOCCompletionTable -> #table.
NOCCompletionTable -> #classTable.
Locale -> #Current.
Locale -> #CurrentPlatform.
DateAndTime -> #LocalTimeZone.
FT2Handle -> #Session.
FileLocator -> #Resolver.
FileStream -> #Stdin.
FileStream -> #Stdout.
FileStream -> #TheStdioHandles.
FileStream -> #StdioFiles.
FileStream -> #Stderr.
LanguageEnvironment -> #SystemConverter.
LanguageEnvironment -> #FileNameConverter.
UUIDGenerator -> #Default.
VirtualMachine -> #WordSize.
WeakFinalizationList -> #HasNewFinalization.
AthensCairoSurface -> #uniqueSession.
AthensCairoSurface -> #dispatch.
AthensCairoSurface -> #dispatchStruct.
CairoLibraryLoader -> #session .
CairoLibraryLoader -> #libHandle.
Session -> #current.
MultiByteFileStream -> #LineEndDefault} asSet! !

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 20:46'!
autoDetectedBaseClassSingletonVars

	|classToCacheAssocList|
	classToCacheAssocList := OrderedCollection new.
	ProtoObject allSubclasses do: [ :class | 
		class isMeta 
			ifFalse: [ |rNew1 rNew2 rDefault ivName|
				[ rNew1 := class new. rNew2 := class new ] 
					on: Exception 
					do: [ class respondsTo: #default ifTrue: [rDefault := class default]].
				[(((rNew1 ~= nil) & (rNew1 == rNew2)) | (rDefault ~= nil))
					ifTrue: [  
							ivName := self cacheForClass: class withValue: (rDefault ifNil: [ rNew1  ])
							ivName ifNotNil: [ classToCacheAssocList add: class -> ivName asSymbol ]
					]] on: Exception do: [ "various results of new behave unexpectedly like MessageCather etc" ] 	
			 ]
	].
	^ classToCacheAssocList asSet! !

!NaiveCacheDetector methodsFor: 'helpers' stamp: 'NickPapoulias 9/8/2015 20:15'!
cacheForClass: aClass withValue: aValue

	aClass instanceVariables do: [ :iv | 
		(aClass instVarNamed: iv) == aValue ifTrue: [ ^ iv ]	
	].
	^ nil! !

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 20:36'!
cacheNamedClassVars

	| classToCacheAssocList |
	classToCacheAssocList := OrderedCollection new.
	ProtoObject allSubclasses do: [ :class | 
		class ~= NaiveCacheDetector ifTrue: [  
			(self cachesForClassInClassVars: class)
				ifNotEmptyDo: [:caches | 
						caches do: [ :cache | classToCacheAssocList add: class -> cache asSymbol ]]
		]
	].
	^ classToCacheAssocList asSet! !

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 20:40'!
cacheNamedIVs

	| classToCacheAssocList |
	classToCacheAssocList := OrderedCollection new.
	ProtoObject allSubclasses do: [ :class |
		class ~= NaiveCacheDetector ifTrue: [   
			(self cachesForClass: class) 
				ifNotEmptyDo: [:caches | 
					caches do: [ :cache | classToCacheAssocList add: class -> cache asSymbol ]].
		]
	].
	^ classToCacheAssocList asSet! !

!NaiveCacheDetector methodsFor: 'detectors' stamp: 'NickPapoulias 9/8/2015 20:41'!
cacheNamedTemporaries

	methodToCacheAssocList ifNotNil: [ ^ methodToCacheAssocList ]. "takes time to compute cache it ;) -- is not counted for detection"
	methodToCacheAssocList := OrderedCollection new.
	CompiledMethod allInstances do: [ :method | 
		method methodClass ~= NaiveCacheDetector ifTrue: [  
			(self cachesForMethod: method) 
				ifNotEmptyDo: [:caches | 
						caches do: [ :cache | methodToCacheAssocList add: method -> cache asSymbol ]].
		].
	].
	^ methodToCacheAssocList := methodToCacheAssocList asSet! !

!NaiveCacheDetector methodsFor: 'helpers' stamp: 'NickPapoulias 9/2/2015 17:43'!
cachesForClass: aClass

	^ aClass instanceVariables ifNil: [ {  } ] ifNotNilDo: 
		[:ivs | (ivs select: [ :iv | iv includesSubstring: 'cache' caseSensitive: false ]) asOrderedCollection ]! !

!NaiveCacheDetector methodsFor: 'helpers' stamp: 'NickPapoulias 9/2/2015 17:43'!
cachesForClassInClassVars: aClass

	^ aClass classVarNames ifNil: [ {  } ] ifNotNilDo: 
		[:ivs | (ivs select: [ :iv | iv includesSubstring: 'cache' caseSensitive: false ]) asOrderedCollection ]! !

!NaiveCacheDetector methodsFor: 'helpers' stamp: 'NickPapoulias 9/8/2015 20:26'!
cachesForMethod: aMethod

	^ aMethod tempNames ifNil: [ {  } ] ifNotNilDo: 
		[:temps | (temps select: [ :temp | temp includesSubstring: 'cache' caseSensitive: false ]) asOrderedCollection ]! !

!NaiveCacheDetector methodsFor: 'full - union - intersection' stamp: 'NickPapoulias 9/8/2015 18:11'!
intersectionOfAutoAndManualDetected

	^ self allAutomaticallyDetectedCaches intersection: self allManuallyDetectedCaches.
		! !

Object subclass: #PlaygroundAnalysisSetNick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/2/2015 12:34'!
browseAllAccessesTo: aVar from: aClass

	SystemNavigation default browseAllAccessesTo: aVar from: aClass! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/2/2015 12:43'!
browseAllAccessesToClassVar: aVar from: aClass

	SystemNavigation default browseAllReferencesTo:
		(aClass classPool associationAt: aVar)! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 17:01'!
infoOnClassSideIV: ivName inClass: aClass! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 17:04'!
infoOnClassVariable: cvarName inClass: aClass! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 17:01'!
infoOnInstanceSideIV: ivName inClass: aClass! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/8/2015 18:11'!
manualExample

	PlaygroundAnalysisSetNick new browseAllAccessesToClassVar: #DownloadCache from: MCGitHubRepository.  

	(MCGitHubRepository classPool at: #DownloadCache) class.
	(MCGitHubRepository classPool at: #DownloadCache) size.
	(MCGitHubRepository classPool at: #DownloadCache) anyOne class.! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/8/2015 18:11'!
manualExampleClassPool

	PlaygroundAnalysisSetNick new browseAllAccessesToClassVar: #DownloadCache from: MCGitHubRepository.  

	(MCGitHubRepository classPool at: #DownloadCache) class.
	(MCGitHubRepository classPool at: #DownloadCache) size.
	(MCGitHubRepository classPool at: #DownloadCache) anyOne class.! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/8/2015 18:11'!
manualExampleInstanceSide

	|instance|

	PlaygroundAnalysisSetNick new browseAllAccessesTo: #cachedPresentation from: GLMDynamicPresentation.  
	
	instance := GLMDynamicPresentation allInstances isEmpty
						ifTrue: [ GLMDynamicPresentation new ]
						ifFalse: [ GLMDynamicPresentation allInstances anyOne ].

	(instance instVarNamed: #cachedPresentation) class.
	(instance instVarNamed: #cachedPresentation) size.
	(instance instVarNamed: #cachedPresentation) anyOne class.! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:44'!
manuallyIDedIWSTpaperSession

	^  { FileStream -> #Stderr.
LanguageEnvironment -> #SystemConverter.
LanguageEnvironment -> #FileNameConverter.
UUIDGenerator -> #Default.
VirtualMachine -> #WordSize.
WeakFinalizationList -> #HasNewFinalization.
AthensCairoSurface -> #uniqueSession.
AthensCairoSurface -> #dispatch.
AthensCairoSurface -> #dispatchStruct.
CairoLibraryLoader -> #session.
CairoLibraryLoader -> #libHandle.
Session -> #current.
MultiByteFileStream -> #LineEndDefault. }! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/2/2015 20:10'!
manuallyIDedIWSTpaperSingletons

	^ {NNavNavigation -> #Instance.
NativeBoost -> #Current.
NautilusMonticello -> #Default.
OSPlatform -> #Current.
"PackageOrganizer -> #default."
PharoFilesOpener -> #Default.
"PharoTutorial -> #Instance."
ProcessSpecificVariable -> #soleInstance.
Processor -> #Processor.
RBRefactoringManager -> #Instance.
RBRefactoryChangeManager -> #Instance.
RPackageOrganizer -> #default.
RecentMessageList -> #UniqueInstance.
Sensor -> #Sensor.
"SharedValueHolder -> #instance"
Smalltalk -> #Smalltalk.
SoundTheme -> #Current.
SourceFiles -> #SourceFiles.
"Spotlight -> #Current"
StartupPreferencesLoader -> #UniqueInstance.
SystemAnnouncer -> #announcer.
SystemOrganization -> #SystemOrganization.
SystemProgressMorph -> #UniqueInstance.
SystemVersion -> #Current.
Transcript -> #Transcript.
UUIDGenerator -> #Default.
Undeclared -> #Undeclared.
"UserManager -> #default"
VTermOutputDriver -> #stderrTerminalInstance.
VTermOutputDriver -> #stdoutTerminalInstance.
World -> #World.
ZnNetworkingUtils -> #Default}! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:42'!
manuallyIDedIWSTpaperVarious

	^ { MCDefinition -> #Instances.
MCGitHubRepository -> #DownloadCache.
MCMethodDefinition -> #Definitions.
MCSaveVersionDialog -> #PreviousMessages.
NECSymbols -> #cachedSymbols.
RPackageSet -> #cachePackages.
ScrollBar -> #ArrowImagesCache.
ScrollBar -> #BoxesImagesCache.
SettingDeclaration -> #ValueListCache.
SingleCodeCriticResultList -> #icons.
SugsSuggestionFactory -> #collectorForAll.
SugsSuggestionFactory -> #collectorForAssignment.
SugsSuggestionFactory -> #collectorForClassVariable.
SugsSuggestionFactory -> #collectorForClass.
SugsSuggestionFactory -> #collectorForInstancesVariable.
SugsSuggestionFactory -> #collectorForLiteral.
SugsSuggestionFactory -> #collectorForMessage.
SugsSuggestionFactory -> #collectorForMethod.
SugsSuggestionFactory -> #collectorForSourceCode.
SugsSuggestionFactory -> #collectorForTemporaryVariable.
SugsSuggestionFactory -> #collectorForUndeclaredVariable. }! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:31'!
naiveDetectorCacheIvs

	 ^ {GLMDynamicPresentation->#(#cachedPresentation). PNGReadWriter->#(#cachedDecoderMap). Color->#(#cachedDepth #cachedBitPattern). TextContainer->#(''rectangleCache''). MetacelloCommonMCSpecLoader->#(''disablePackageCache''). FreeTypeFont->#(''widthAndKernedWidthCache'' ''cachedHeight'' ''cachedAscent'' ''cachedDescent''). RBVariableEnvironment->#(''selectorCache''). ColorForm->#(''cachedDepth'' ''cachedColormap''). SystemDictionary->#(''cachedClassNames'' ''cachedNonClassNames''). SpecDebuggerStack->#(#actionsCache). NECSymbols class->#(''cachedSymbols''). EmbeddedFreeTypeFontInstaller->#(#embeddedFileInfoCache). StackLayout->#(''cachedMinExtent'' ''cachedMinExtents''). FreeTypeFontProvider->#(#fileInfoCache). MetacelloCachingGoferResolvedReference->#(''cachedVersion''). RowLayout->#(''cachedMinExtent'' ''cachedMinExtents''). MCHttpRepository->#(#readerCache). HandMorph->#(#cacheCanvas #cachedCanvasHasHoles). MessageBrowser->#(#cachedHierarchy). NewListModel->#(#listItemsCache). GTSpotterContext->#(#cache). RBNamespace->#(''implementorsCache'' ''sendersCache''). ListModel->#(#listItemsCache). RBSentNotImplementedRule->#(#implementorsCache). MetacelloLoaderPolicy->#(''cacheRepository'' ''cacheGofer''). VSCommitBrowser class->#(#commentCache). Termcap->#(''cache''). TableLayout->#(''minExtentCache''). SeamlessFastDNUProxy->#(#cachedClassProxy). PluggableListMorph->#(#hScrollRangeCache). FileDialogWindow->#(#entryCache #entryCacheDirectory). InteractiveResolver->#(''cache''). MailAddressTokenizer->#(#cachedToken). ClassWidget->#(#cachedHierarchy). GoferSynchronize->#(''cacheReferences''). GLMDynamicPresentation2->#(#cachedPresentation). ASTCacheResetTest->#(#cache). MCRepositoryGroup->#(''useCache''). CairoFontMetricsProvider->#(#cache). Gofer->#(''packageCacheRepository'' ''resolvedReferencesCache''). ProgressBarMorph->#(#cachedWidth). MethodFinder->#(#cachedClass #cachedArgNum #cachedSelectorLists). MCCacheRepository->#(#packageCaches #cacheEnabled). RPackageSet class->#(#cacheActive #cachePackages). MetacelloClearStackCacheNotification->#(''cacheNames''). HelpBrowser->#(#helpTopicCache). CharacterSetComplement->#(''byteArrayMapCache''). AlphaImageMorph->#(#cachedForm). CairoFreetypeFontRenderer->#(#cache). MCFileTreeWriter->#(#cachedPackageFileDirectoryEntries). GLMPresentation->#(#cachedDisplayedValue). GTPlayBook class->#(#cacheDirectory). MCFileBasedRepository->#(#cache #cacheFileNames). GLMPane->#(#cachedMatchingPresentations). NewList->#(#listCache #displayListCache #iconCache). CriticBrowser->#(#cache). SingleCodeCriticResultList->#(#cache). AbstractNautilusUI->#(#cachedHierarchy). FreeTypeCacheTest->#(''cache'' ''cache1K'' ''fullCache''). SmalllintManifestChecker->#(''manifestClassCache''). CairoBackendCache->#(''cache''). MCMczReader->#(''infoCache'')}! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/2/2015 14:03'!
naiveLRUUsers

	 ^ {BlockClosureTest->#testMemoizedLRUCache . GradientFillStyle class->#initPixelRampCache . LRUCacheTests->#newCache . ThemeIcons->#initializeIcons . UITheme->#createArrowImagesCache . UITheme->#createBoxImagesCache}
! !

!PlaygroundAnalysisSetNick methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 9/1/2015 13:39'!
naiveTTLUsers

	 ^ {TTLCacheTests->#newCache}! !

Object subclass: #VarEvent
	instanceVariableNames: 'method receiver timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarEvent subclass: #MsgSendEvent
	instanceVariableNames: 'sender selector args'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarEvent subclass: #ReadEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarEvent subclass: #WriteEvent
	instanceVariableNames: 'classOfValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

Object subclass: #VarSite
	instanceVariableNames: 'method node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarSite subclass: #ReadVarSite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarSite subclass: #WriteVarSite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

Object subclass: #VarTrace
	instanceVariableNames: 'classOfVar name proxy testClass initValue timeSortedEvents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarTrace subclass: #ClassSideIVarTrace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarTrace subclass: #ClassVarTrace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarTrace subclass: #InstSideIVarTrace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!

VarTrace subclass: #TempVarTrace
	instanceVariableNames: 'methodOfVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cache-Analysis'!
